use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

pub type VkPhysicalDeviceMemoryProperties2 = VkPhysicalDeviceMemoryProperties2KHR;

#[repr(C)]
#[derive(Debug)]
pub struct VkPhysicalDeviceMemoryProperties2KHR {
    pub sType: VkStructureType,
    pub pNext: *mut c_void,
    pub memoryProperties: VkPhysicalDeviceMemoryProperties,
}

impl VkPhysicalDeviceMemoryProperties2KHR {
    pub fn new(memory_properties: VkPhysicalDeviceMemoryProperties) -> Self {
        VkPhysicalDeviceMemoryProperties2KHR {
            sType: VK_STRUCTURE_TYPE_PHYSICAL_DEVICE_MEMORY_PROPERTIES_2,
            pNext: ptr::null_mut(),
            memoryProperties: memory_properties,
        }
    }
}

impl Default for VkPhysicalDeviceMemoryProperties2KHR {
    fn default() -> Self {
        Self::new(VkPhysicalDeviceMemoryProperties::default())
    }
}

impl_pnext_out!(
    VkPhysicalDeviceMemoryProperties2KHR,
    VkPhysicalDeviceMemoryBudgetPropertiesEXT
);
